CREATE TABLE APPROVAL_TYPES (
APPROVAL_TYPE VARCHAR2(50 CHAR) NOT NULL,
AMOUNT NUMBER,
VALID_IN_DAYS NUMBER,
ALARM_DESCRIPTION VARCHAR2(250 CHAR),
APPROVAL_RIGHT VARCHAR2(250 CHAR) NOT NULL,
ACTIVE VARCHAR2(1 CHAR) NOT NULL,
CONSTRAINT PK_APPROVAL_TYPES PRIMARY KEY(APPROVAL_TYPE)
)
;

CREATE TABLE APPROVALS (
ID_APPROVAL NUMBER NOT NULL,
APPROVAL_TYPE VARCHAR2(50 CHAR) NOT NULL,
DATE_OF_REQUEST DATE NOT NULL,
DATE_OF_EXPIRATION DATE NOT NULL,
TABLE_NAME VARCHAR2(250 CHAR),
ID NUMBER,
CODE VARCHAR2(250 CHAR),
USERNAME VARCHAR2(100 CHAR) NOT NULL,
ID_OWNER NUMBER,
ID_VESSEL NUMBER,
AMOUNT NUMBER,
APPROVAL_COMMENT VARCHAR2(250 CHAR),
APPROVED_BY VARCHAR2(250 CHAR),
APPROVAL_TIME DATE,
APPROVED VARCHAR2(1 CHAR),
APPROVAL_USED VARCHAR2(1 CHAR),
CONSTRAINT PK_APPROVALS PRIMARY KEY(ID_APPROVAL)
)
;

CREATE SEQUENCE APPROVALS_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE
;

CREATE INDEX IX_APPROVALS1 ON APPROVALS (APPROVAL_TYPE, TABLE_NAME, ID)
;

CREATE INDEX IX_APPROVALS2 ON APPROVALS (APPROVAL_TYPE, TABLE_NAME, CODE)
;

INSERT INTO APPROVAL_TYPES (APPROVAL_TYPE, AMOUNT, APPROVAL_RIGHT, ACTIVE, ALARM_DESCRIPTION, VALID_IN_DAYS) 
values
('REFUND', null, 'PAYMENT_REFUND_APPROVAL', 'N', 'Refund approval required', 7)
;

CREATE OR REPLACE VIEW V_REFUND_PAYM_TYPE AS (
select slo AS ID, slo AS OPIS from nknjizba where refund = 'Y'
union
select opis AS ID, opis AS OPIS from nncards where refund = 'Y'
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2322, SYSDATE, '5.5', 2242, 'APPROVALS')
;
